#include <cube.h>
#include <engine/engine.h>
#include <engine/collision.h>
#include <sphere.h>

void Cube::pre_render()  {
    //hVelocity = 1;
    hMove(velAngle, hVelocity);
    vMove(vVelocity);

    Moby* moby;
    for (auto& e : engine->world->GetChildren())
        if (auto* m = dynamic_cast<Sphere2*>(e))
            if (m->name == "sphere")
                moby = m;
    if (moby == this)
        return;

    if (collidable && moby->collidable && isCollidingWith(moby)) {
        moby->velAngle = moby->lAngle();
        velAngle = rAngle();
    }
    angle.x = angle.x + 24*engine->frameDelta;
    angle.y = angle.y + 24*engine->frameDelta;
    angle.z = angle.z + 24*engine->frameDelta;
}

void Cube::update(float elapsed) {

}


    Cube::Cube() {
    name = "cube";
    modelPath = "assets/models/cube.obj";
    texturePath = "assets/textures/multi/";
    setScale(1.0f);
    hVelocity = 0;
    vVelocity = 0;
}

Collider Cube::getCollider() {
   Collider collider = Collision::calculateAxisAlignedBoundingBox(getGeometry()->getBoundingVolume(angle));

    //Scale.
    for (auto& vertex : collider.vertices) {
        vertex.x *= getScale();
        vertex.y *= getScale();
        vertex.z *= getScale();
    }

    //To world space.
    for (auto& vertex : collider.vertices) {
        vertex.x = vertex.x + position.x;
        vertex.y = vertex.y + position.y;
        vertex.z = vertex.z + position.z;
    }

    return collider;
}

void Cube::loadTexture() {
    MultiTexture texture(name, texturePath.c_str(), true);
}
