#include <sphere.h>
#include <engine/collision.h>
void Sphere2::pre_render()  {
    hVelocity = 1;
    hMove(velAngle, hVelocity);
    vMove(vVelocity);
}

void Sphere2::update(float elapsed) {

}


Sphere2::Sphere2() {
    name = "sphere";
    modelPath = "assets/models/sphere_lo.obj";
    texturePath = "assets/textures/missing.png";
    setScale(1.f);
    hVelocity = 0;
    vVelocity = 0;
}

Collider Sphere2::getCollider() {
    Collider collider;
    //collider.angle = angle;
    collider.vertices = getGeometry()->vertices;
    collider.indices = getGeometry()->indices;
    collider.type = ColliderType::CollisionMap;

    //Scale.
    for (auto& vertex : collider.vertices) {
        vertex.x *= getScale();
        vertex.y *= getScale();
        vertex.z *= getScale();
    }

    //To world space.
    for (auto& vertex : collider.vertices) {
        vertex.x = vertex.x + position.x;
        vertex.y = vertex.y + position.y;
        vertex.z = vertex.z + position.z;
    }

    return collider;
}
